.\"     $NetBSD: whois.1,v 1.24 2007/09/09 18:31:45 christos Exp $
.\"	$OpenBSD: whois.1,v 1.22 2003/09/02 18:50:07 jmc Exp $
.\"
.\" Copyright (c) 1985, 1990, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)whois.1	8.2 (Berkeley) 6/20/94
.\"
.Dd September 9, 2007
.Dt WHOIS 1
.Os
.Sh NAME
.Nm whois
.Nd Internet domain name and network number directory service
.Sh SYNOPSIS
.Nm whois
.Op Fl 6AadfgilmQRr
.Oo
.Fl c Ar country-code | Fl h Ar host
.Oc
.Op Fl p Ar port
.Ar name Op Ar ...
.Sh DESCRIPTION
The
.Nm
utility looks up records in the databases maintained by several
Network Information Centers
.Pq Tn NICs .
.Pp
The options are as follows:
.Bl -tag -width Ds
.It Fl 6
Use the IPv6 Resource Center
.Pq Tn 6bone
database.
It contains network names and addresses for the IPv6 network.
.It Fl A
Use the Asia/Pacific Network Information Center
.Pq Tn APNIC
database.
It contains network numbers used in East Asia, Australia,
New Zealand, and the Pacific islands.
.It Fl a
Use the American Registry for Internet Numbers
.Pq Tn ARIN
database.
It contains network numbers used in those parts of the world
not covered by
.Tn AfriNIC ,
.Tn APNIC ,
.Tn LACNIC
or by
.Tn RIPE .
.Pp
(Hint: All point of contact handles in the
.Tn ARIN
whois database end with
.Qq Li -ARIN . )
.It Fl c Ar country-code
This is the equivalent of using the
.Fl h
option with an argument of
.Qq Ar country-code Ns Li .whois-servers.net .
.It Fl d
Use the US Department of Defense database.
It contains points of contact for subdomains of
.Tn \&.MIL .
.It Fl f
Use the African Network Information Center
.Pq Tn AfriNIC
database.
It contains network numbers used in Africa.
.It Fl g
Use the US non-military federal government database, which contains points of
contact for subdomains of
.Tn \&.GOV .
.It Fl h Ar host
Use the specified host instead of the default NIC
(whois.crsnic.net).
Either a host name or an IP address may be specified.
.Pp
By default
.Nm
constructs the name of a whois server to use from the top-level domain
.Pq Tn TLD
of the supplied (single) argument, and appending
.Qq Li .whois-servers.net .
This effectively allows a suitable whois server to be selected
automatically for a large number of
.Tn TLDs .
.Pp
In the event that an IP
address is specified, the whois server will default to the American
Registry for Internet Numbers
.Pq Tn ARIN .
If a query to
.Tn ARIN
references
.Tn AfriNIC, APNIC , LACNIC ,
or
.Tn RIPE ,
that server will be queried also, provided that the
.Fl Q
option is not specified.
.Pp
If the query is not a domain name or IP address,
.Nm
will fall back to
.Pa whois.crsnic.net .
.It Fl i
Use the Network Solutions Registry for Internet Numbers
.Pq Tn whois.networksolutions.com
database.
Historically, it contained network numbers and domain contact information
for most of
.Tn \&.COM ,
.Tn \&.NET ,
.Tn \&.ORG
and
.Tn \&.EDU
domains.
However, the registration of these domains is now done by a number of
independent and competing registrars and this database holds no information
on the domains registered by organizations other than Network Solutions, Inc.
Also, note that the
.Tn InterNIC
database
.Pq Pa whois.internic.net
is no longer handled by Network Solutions, Inc.
For details, see
.Pa http://www.internic.net/ .
.Pp
(Hint: Contact information, identified by the term
.Em handle ,
can be looked up by prefixing
.Qq Li \&!
or
.Qq Li handle\ \&
to the
.Tn NIC
handle in the query.)
.It Fl l
Use the Latin American and Caribbean IP address Regional Registry
.Pq Tn LACNIC
database.
It contains network numbers used in much of Latin America and the
Caribbean.
.It Fl m
Use the Route Arbiter Database
.Pq Tn RADB
database.
It contains route policy specifications for a large
number of operators' networks.
.It Fl p Ar port
Connect to the whois server on
.Ar port .
If this option is not specified,
.Nm
defaults to the
.Dq whois
port listed in
.Pa /etc/services
(port 43).
.It Fl Q
Do a quick lookup.
This means that
.Nm
will not attempt to lookup the name in the authoritative whois
server (if one is listed) nor will it contact InterNic if a lookup
fails.
This flag has no effect when combined with any other flag.
.It Fl R
Use the Russia Network Information Center
.Pq Tn RIPN
database.
It contains network numbers and domain contact information
for subdomains of
.Tn \&.RU .
This option is deprecated; use the
.Fl c
option with an argument of
.Qq Li RU
instead.
.It Fl r
Use the R\(aaeseaux IP Europ\(aaeens
.Pq Tn RIPE
database.
It contains network numbers and domain contact information for Europe.
.El
.Pp
The default action, unless directed otherwise with a special
.Ar name ,
is to do a very broad search, looking for matches to
.Ar name
in all types of records and most fields (name, nicknames, hostname, net
address, etc.) in the database.
For more information as to what
.Ar name
operands have special meaning, and how to guide the search, use
the special name
.Dq help .
.Ss Special cases
Queries beginning with an exclamation point
.Ql \&!
are assumed to be
.Tn NSI
contact handles.
Unless a host or domain is specified on the command line,
.Pq Tn whois.networksolutions.com
will be used as the
.Nm
database.
.Pp
Similarly, queries beginning with
.Dq COCO-
are assumed to be
.Tn CORE
contact handles.
Unless a host or domain is specified on the command line,
.Pq Tn whois.corenic.net
will be used as the
.Nm
database.
.Sh EXAMPLES
Most types of data, such as domain names and
.Tn IP
addresses, can be used as arguments to
.Nm
without any options, and
.Nm
will choose the correct whois server to query.
Some exceptions, where
.Nm
will not be able to handle data correctly, are detailed below.
.Pp
To obtain contact information about an
administrator located in the Russian
.Tn TLD
domain
.Qq Li RU ,
use the
.Fl c
option as shown in the following example, where
.Ar CONTACT-ID
is substituted with the actual contact identifier.
.Pp
.Dl "whois -c RU CONTACT-ID"
.Pp
(Note: This example is specific to the
.Tn TLD
.Qq Li RU ,
but other
.Tn TLDs
can be queried by using a similar syntax.)
.Pp
The following example demonstrates how to obtain information about an
.Tn IPv6
address or hostname using the
.Fl 6
option, which directs the query to
.Tn 6bone .
.Pp
.Dl "whois -6 IPv6-IP-Address"
.Pp
The following example demonstrates how to query
a whois server using a non-standard port, where
.Dq Li query-data
is the query to be sent to
.Dq Li whois.example.com
on port
.Dq Li rwhois
(written numerically as 4321).
.Pp
.Dl "whois -h whois.example.com -p rwhois query-data"
.Sh SEE ALSO
.Rs
.%A Ken Harrenstien
.%A Vic White
.%T NICNAME/WHOIS
.%D 1 March 1982
.%O RFC 812
.Re
.Sh HISTORY
The
.Nm
command appeared in
.Bx 4.3 .
